]> git.saurik.com Git - apt.git/blob - cmdline/apt-key.in
d50ad40ac1d8e5c14bbc72f0a9336e91129a4084
[apt.git] / cmdline / apt-key.in
1 #!/bin/sh
2
3 set -e
4 unset GREP_OPTIONS
5
6 GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring"
7
8 # gpg needs (in different versions more or less) files to function correctly,
9 # so we give it its own homedir and generate some valid content for it
10 GPGHOMEDIR="$(mktemp -d)"
11 CURRENTTRAP="${CURRENTTRAP} rm -rf '${GPGHOMEDIR}';"
12 trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
13 chmod 700 "$GPGHOMEDIR"
14 # We don't use a secret keyring, of course, but gpg panics and
15 # implodes if there isn't one available - and writeable for imports
16 SECRETKEYRING="${GPGHOMEDIR}/secring.gpg"
17 touch $SECRETKEYRING
18 GPG_CMD="$GPG_CMD --homedir $GPGHOMEDIR"
19 # create the trustdb with an (empty) dummy keyring
20 # older gpgs required it, newer gpgs even warn that it isn't needed,
21 # but require it nonetheless for some commands, so we just play safe
22 # here for the foreseeable future and create a dummy one
23 $GPG_CMD --quiet --check-trustdb --keyring $SECRETKEYRING >/dev/null 2>&1
24 # tell gpg that it shouldn't try to maintain a trustdb file
25 GPG_CMD="$GPG_CMD --no-auto-check-trustdb --trust-model always"
26
27 GPG="$GPG_CMD"
28
29 APT_DIR="/"
30 eval $(apt-config shell APT_DIR Dir)
31
32 MASTER_KEYRING='&keyring-master-filename;'
33 eval $(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)
34 ARCHIVE_KEYRING='&keyring-filename;'
35 eval $(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)
36 REMOVED_KEYS='&keyring-removed-filename;'
37 eval $(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)
38 ARCHIVE_KEYRING_URI='&keyring-uri;'
39 eval $(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)
40 TMP_KEYRING=${APT_DIR}/var/lib/apt/keyrings/maybe-import-keyring.gpg
41
42 aptkey_echo() { echo "$@"; }
43
44 requires_root() {
45 if [ "$(id -u)" -ne 0 ]; then
46 echo >&1 "ERROR: This command can only be used by root."
47 exit 1
48 fi
49 }
50
51 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
52 init_keyring() {
53 for path; do
54 if ! [ -e "$path" ]; then
55 touch -- "$path"
56 chmod 0644 -- "$path"
57 fi
58 done
59 }
60
61 add_keys_with_verify_against_master_keyring() {
62 ADD_KEYRING=$1
63 MASTER=$2
64
65 if [ ! -f "$ADD_KEYRING" ]; then
66 echo "ERROR: '$ADD_KEYRING' not found"
67 return
68 fi
69 if [ ! -f "$MASTER" ]; then
70 echo "ERROR: '$MASTER' not found"
71 return
72 fi
73
74 # when adding new keys, make sure that the archive-master-keyring
75 # is honored. so:
76 # all keys that are exported must have a valid signature
77 # from a key in the $distro-master-keyring
78 add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
79 all_add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5`
80 master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
81
82 # ensure there are no colisions LP: #857472
83 for all_add_key in $all_add_keys; do
84 for master_key in $master_keys; do
85 if [ "$all_add_key" = "$master_key" ]; then
86 echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted"
87 return 1
88 fi
89 done
90 done
91
92 for add_key in $add_keys; do
93 # export the add keyring one-by-one
94 rm -f $TMP_KEYRING
95 $GPG_CMD --keyring $ADD_KEYRING --output $TMP_KEYRING --export $add_key
96 # check if signed with the master key and only add in this case
97 ADDED=0
98 for master_key in $master_keys; do
99 if $GPG_CMD --keyring $MASTER --keyring $TMP_KEYRING --check-sigs --with-colons $add_key | grep '^sig:!:' | cut -d: -f5 | grep -q $master_key; then
100 $GPG --import $TMP_KEYRING
101 ADDED=1
102 fi
103 done
104 if [ $ADDED = 0 ]; then
105 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
106 fi
107 done
108 rm -f $TMP_KEYRING
109 }
110
111 # update the current archive signing keyring from a network URI
112 # the archive-keyring keys needs to be signed with the master key
113 # (otherwise it does not make sense from a security POV)
114 net_update() {
115 # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128))
116 APT_KEY_NET_UPDATE_ENABLED=""
117 eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled)
118 if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then
119 exit 1
120 fi
121
122 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
123 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
124 exit 1
125 fi
126 requires_root
127 # in theory we would need to depend on wget for this, but this feature
128 # isn't useable in debian anyway as we have no keyring uri nor a master key
129 if ! which wget >/dev/null 2>&1; then
130 echo >&2 "ERROR: an installed wget is required for a network-based update"
131 exit 1
132 fi
133 if [ ! -d ${APT_DIR}/var/lib/apt/keyrings ]; then
134 mkdir -p ${APT_DIR}/var/lib/apt/keyrings
135 fi
136 keyring=${APT_DIR}/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING_URI)
137 old_mtime=0
138 if [ -e $keyring ]; then
139 old_mtime=$(stat -c %Y $keyring)
140 fi
141 (cd ${APT_DIR}/var/lib/apt/keyrings; wget --timeout=90 -q -N $ARCHIVE_KEYRING_URI)
142 if [ ! -e $keyring ]; then
143 return
144 fi
145 new_mtime=$(stat -c %Y $keyring)
146 if [ $new_mtime -ne $old_mtime ]; then
147 aptkey_echo "Checking for new archive signing keys now"
148 add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING
149 fi
150 }
151
152 update() {
153 if [ ! -f $ARCHIVE_KEYRING ]; then
154 echo >&2 "ERROR: Can't find the archive-keyring"
155 echo >&2 "Is the &keyring-package; package installed?"
156 exit 1
157 fi
158 requires_root
159
160 # add new keys from the package;
161
162 # we do not use add_keys_with_verify_against_master_keyring here,
163 # because "update" is run on regular package updates. A
164 # attacker might as well replace the master-archive-keyring file
165 # in the package and add his own keys. so this check wouldn't
166 # add any security. we *need* this check on net-update though
167 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
168
169 if [ -r "$REMOVED_KEYS" ]; then
170 # remove no-longer supported/used keys
171 keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
172 for key in $keys; do
173 if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then
174 $GPG --quiet --batch --delete-key --yes ${key}
175 fi
176 done
177 else
178 echo "Warning: removed keys keyring $REMOVED_KEYS missing or not readable" >&2
179 fi
180 }
181
182 remove_key_from_keyring() {
183 local GPG="$GPG_CMD --keyring $1"
184 # check if the key is in this keyring: the key id is in the 5 column at the end
185 if ! $GPG --with-colons --list-keys 2>&1 | grep -q "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+$2:"; then
186 return
187 fi
188 if [ ! -w "$1" ]; then
189 echo >&2 "Key ${2} is in keyring ${1}, but can't be removed as it is read only."
190 return
191 fi
192 # check if it is the only key in the keyring and if so remove the keyring altogether
193 if [ '1' = "$($GPG --with-colons --list-keys | grep "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+:" | wc -l)" ]; then
194 mv -f "$1" "${1}~" # behave like gpg
195 return
196 fi
197 # we can't just modify pointed to files as these might be in /usr or something
198 local REALTARGET
199 if [ -L "$1" ]; then
200 REALTARGET="$(readlink -f "$1")"
201 mv -f "$1" "${1}.dpkg-tmp"
202 cp -a "$REALTARGET" "$1"
203 fi
204 # delete the key from the keyring
205 $GPG --batch --delete-key --yes "$2"
206 if [ -n "$REALTARGET" ]; then
207 # the real backup is the old link, not the copy we made
208 mv -f "${1}.dpkg-tmp" "${1}~"
209 fi
210 }
211
212 remove_key() {
213 requires_root
214
215 # if a --keyring was given, just remove from there
216 if [ -n "$FORCED_KEYRING" ]; then
217 remove_key_from_keyring "$FORCED_KEYRING" "$1"
218 else
219 # otherwise all known keyrings are up for inspection
220 local TRUSTEDFILE="/etc/apt/trusted.gpg"
221 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
222 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
223 remove_key_from_keyring "$TRUSTEDFILE" "$1"
224 TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
225 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
226 if [ -d "$TRUSTEDPARTS" ]; then
227 for trusted in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
228 remove_key_from_keyring "$trusted" "$1"
229 done
230 fi
231 fi
232 aptkey_echo "OK"
233 }
234
235
236 usage() {
237 echo "Usage: apt-key [--keyring file] [command] [arguments]"
238 echo
239 echo "Manage apt's list of trusted keys"
240 echo
241 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
242 echo " apt-key del <keyid> - remove the key <keyid>"
243 echo " apt-key export <keyid> - output the key <keyid>"
244 echo " apt-key exportall - output all trusted keys"
245 echo " apt-key update - update keys using the keyring package"
246 echo " apt-key net-update - update keys using the network"
247 echo " apt-key list - list keys"
248 echo " apt-key finger - list fingerprints"
249 echo " apt-key adv - pass advanced options to gpg (download key)"
250 echo
251 echo "If no specific keyring file is given the command applies to all keyring files."
252 }
253
254 while [ -n "$1" ]; do
255 case "$1" in
256 --keyring)
257 shift
258 TRUSTEDFILE="$1"
259 FORCED_KEYRING="$1"
260 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ] || [ "$2" = 'adv' ]; then
261 GPG="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
262 else
263 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
264 exit 1
265 fi
266 shift
267 ;;
268 --fakeroot)
269 requires_root() { true; }
270 shift
271 ;;
272 --quiet)
273 aptkey_echo() { true; }
274 shift
275 ;;
276 --*)
277 echo >&2 "Unknown option: $1"
278 usage
279 exit 1;;
280 *)
281 break;;
282 esac
283 done
284
285 if [ -z "$TRUSTEDFILE" ]; then
286 TRUSTEDFILE="/etc/apt/trusted.gpg"
287 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
288 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
289 if [ -r "$TRUSTEDFILE" ]; then
290 GPG="$GPG --keyring $TRUSTEDFILE"
291 fi
292 GPG="$GPG --primary-keyring $TRUSTEDFILE"
293 TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
294 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
295 if [ -d "$TRUSTEDPARTS" ]; then
296 # strip / suffix as gpg will double-slash in that case (#665411)
297 STRIPPED_TRUSTEDPARTS="${TRUSTEDPARTS%/}"
298 if [ "${STRIPPED_TRUSTEDPARTS}/" = "$TRUSTEDPARTS" ]; then
299 TRUSTEDPARTS="$STRIPPED_TRUSTEDPARTS"
300 fi
301 for trusted in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
302 GPG="$GPG --keyring $trusted"
303 done
304 fi
305 fi
306
307 command="$1"
308 if [ -z "$command" ]; then
309 usage
310 exit 1
311 fi
312 shift
313
314 if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
315 echo >&2 "Warning: gnupg does not seem to be installed."
316 echo >&2 "Warning: apt-key requires gnupg for most operations."
317 echo >&2
318 fi
319
320 case "$command" in
321 add)
322 requires_root
323 init_keyring "$TRUSTEDFILE"
324 $GPG --quiet --batch --import "$1"
325 aptkey_echo "OK"
326 ;;
327 del|rm|remove)
328 init_keyring "$TRUSTEDFILE"
329 remove_key "$1"
330 ;;
331 update)
332 init_keyring "$TRUSTEDFILE"
333 update
334 ;;
335 net-update)
336 init_keyring "$TRUSTEDFILE"
337 net_update
338 ;;
339 list)
340 init_keyring "$TRUSTEDFILE"
341 $GPG --batch --list-keys
342 ;;
343 finger*)
344 init_keyring "$TRUSTEDFILE"
345 $GPG --batch --fingerprint
346 ;;
347 export)
348 init_keyring "$TRUSTEDFILE"
349 $GPG --armor --export "$1"
350 ;;
351 exportall)
352 init_keyring "$TRUSTEDFILE"
353 $GPG --armor --export
354 ;;
355 adv*)
356 init_keyring "$TRUSTEDFILE"
357 aptkey_echo "Executing: $GPG $*"
358 $GPG $*
359 ;;
360 help)
361 usage
362 ;;
363 *)
364 usage
365 exit 1
366 ;;
367 esac